<template>
    <div class="container-fluid p-0">
        <div class="row">

            <div class="col-md-2">
                <div class="sidebar">
                    <div class="admin">
                        <img src="../../../assets/images/avatar-05.png" class="avatar-img">
                        <h5>Leapbit</h5>
                        <h6>info@leapbit.com</h6>
                    </div>
                    <div class="navigation">
                        <div class="nav-item">
                            <img src="../../../assets/images/icon-dashboard.svg">
                            <p>Dashboard</p>
                        </div>
                        <div class="nav-item">
                            <img src="../../../assets/images/icon-chat.svg">
                            <p>Chat</p>
                        </div>
                        <div class="nav-item">
                            <img src="../../../assets/images/icon-users.svg">
                            <p>Users</p>
                        </div>
                        <div class="nav-item">
                            <img src="../../../assets/images/icon-settings.svg">
                            <p>Settings</p>
                        </div>
                    </div>
                    <div class="bottom-nav">
                        <div class="nav-item">
                            <img src="../../../assets/images/icon-logout.svg">
                            <p>Logout</p>
                        </div>
                    </div>
                </div>
            </div>

            <div class="col-md-10">
                <div class="row">
                    <div class="col-md-12 vh-header">
                        <div class="col-md-4">
                            <div class="title-new">
                                <h2>Messages</h2>
                            </div>

                            <div class="chats-list">
                                <!--eslint-disable-next-line vue/no-v-for-template-key -->
                                <template v-for="(chat, chatIndex) of chatList" :key="chatIndex">
                                    <div class="chat-single" :class="{ 'active' : (selectedChatId != null && selectedChatId==chat.chatId) }"  @click="openIndividual(chat.chatId)">
                                        <div class="chat-top">
                                            <div class="chat-sender">
                                                <img src="../../../assets/images/avatar-01.png" class="avatar-img">
                                                <div class="name-mail">
                                                    <h3>{{ chat.nameLastName }}</h3>
                                                    <h4>{{ chat.email }}</h4>
                                                </div>
                                            </div>
                                            <p class="time">{{ chat.timestamp }}</p>
                                        </div>
                                        <div class="chat-bottom">
                                            <!-- centered??? -->
                                            <p class="message-preview"> {{ chat.messages[chat.messages.length - 1].msg }}</p>
                                        </div>
                                    </div>
                                </template>
                            </div>
                        </div>
                        <IndividualChatWin :chat="selectedChat" @updatedConvo="pushToChat" />
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import IndividualChatWin from './IndividualChatWin.vue';

export default {
    name: 'AdminWin',
    created()
    {
        const me = this;

        me.$socket.client.emit('admin', '');

        me.init();
    },
    data()
    {
        return {
            activeChat: '123',
            chatList: [],
            chats: {},
            selectedChat: {},
            selectedChatId: null
        };
    },
    sockets: {
        connect() {
            console.log("connected");
        },
        adminMessage(data) {
            const me = this;

            if (me.chats[data.sessionId] == null)
            {
                me.init();
            }
            else
            {
                me.chats[data.sessionId].messages.push(data.message);
            }
        },
    },
    methods: {
        openIndividual(chatId)
        {
            const me = this;
            me.selectedChat = { ...me.chats[chatId]};
            me.selectedChatId = chatId;
        },
        pushToChat(message)
        {
            const me = this;
            me.chats[me.selectedChatId].messages.push(message);
        },
        async init()
        {
            const me = this;
            const dataObject = await me.axios.get('http://localhost:8000/history');
            if (dataObject.data != null)
            {
                for (const eachChat of dataObject.data)
                {
                    if (eachChat.chatId != null)
                    {
                        me.chatList.push(eachChat);

                        if (me.chats[eachChat.chatId] == null)
                        {
                            me.chats[eachChat.chatId] = {};
                        }

                        me.chats[eachChat.chatId] = { ...eachChat };                        
                    }
                }
            }
        },
    },
    components: {
        IndividualChatWin,
    },
};
</script>
